/*******************************************************************************
 *	@file			TCP.cpp
 *	@brief			Network Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			30-Dec-2011(Fri)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "TCP.h"

/*******************************************************************************
 *	@namespace	NET
 ******************************************************************************/
namespace	NET
{

// O[oϐ-----------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				CTCP::AcceptThread( void *p )
 *	@param[in]		p							ėp
 *	@retval			unsigned					TRUE
 *	@brief			FؗpXbh
 ******************************************************************************/
unsigned __stdcall CTCP::AcceptThread( void *p )
{
	CTCP *pTCP = reinterpret_cast<CTCP*>( p );

	// TCP/IP\Pbg̍쐬
	SOCKET Sock;
	Sock = ::WSASocket( AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, 0 );
	if( Sock == INVALID_SOCKET )
	{
		assert( 0 && "AtteThread : WSASocket()" );
		goto ERROR_THREAD;
	}

	// ڑT[o[̃AhXݒ
	SOCKADDR_IN sa_in;
	sa_in.sin_family			= AF_INET;
	sa_in.sin_addr.S_un.S_addr	= ::inet_addr( pTCP->m_cIPAddr );
	sa_in.sin_port				= ::htons( ::atoi( pTCP->m_STcp.m_sPort.c_str() ) );

	// 쐬\PbgɃAhXƃ|[g֘At
	if( ::bind( Sock, reinterpret_cast<SOCKADDR*>( &sa_in ), sizeof( SOCKADDR ) ) != 0 )
	{
		assert( 0 && "AtteThread : bind()" );
		goto ERROR_THREAD;
	}

	// TCP/IPNCAg̐ڑv҂Ԃɐݒ
	if( ::listen( Sock, SOMAXCONN ) != 0 )
	{
		assert( 0 && "AtteThread : listen()" );
		goto ERROR_THREAD;
	}

	pTCP->m_pLog->SetLog( "NET::TCP TCP/IP T[o[ւ̐ڑ҂Jn" );
	// [vŐڑv҂
	while( 1 )
	{
		SOCKET Socket;

		// ACCEPT
		// TCP/IPNCAg̐ڑv󂯕t
		SOCKADDR_IN sa_out;
		int nLen = sizeof( SOCKADDR_IN );
		Socket = ::WSAAccept( Sock, reinterpret_cast<SOCKADDR*>( &sa_out ), &nLen, NULL, NULL );
		if( Socket == INVALID_SOCKET )
		{
			assert( 0 && "AtteThread : WSAAccept()" );
			continue;
		}
		if( SOCKET_ERROR == ::WSAGetLastError() )
		{
			assert( 0 && "AtteThread : WSAAccept()" );
			continue;
		}

		// ڑĂAhXg̏ꍇAIƂ݂Ȃ[vEo
		if( ::strcmp( pTCP->m_cIPAddr, ::inet_ntoa( sa_out.sin_addr ) ) == 0 )
		{
			::closesocket( Socket );
			break;
		}

		// \Pbgڑ
		pTCP->Connect( &Socket, sa_out );

		// WSAAccept() őҋ@AԂsvǔÔ
		::Sleep( 100 );
	}

ERROR_THREAD:
	::shutdown( Sock, SD_BOTH );
	::closesocket( Sock );

	::_endthreadex( 0 );
	return TRUE;
}

/*******************************************************************************
 *	@fn				CTCP::ConnectThread( void *p )
 *	@param[in]		p							ėp
 *	@retval			unsigned					TRUE
 *	@brief			ڑpXbh
 ******************************************************************************/
unsigned __stdcall CTCP::ConnectThread( void *p )
{
	CTCP *pTCP = reinterpret_cast<CTCP*>( p );

	// TCP/IP\Pbg̍쐬
	SOCKET Sock = ::WSASocket( AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, 0 );
	if( Sock == INVALID_SOCKET )
	{
		assert( 0 && "ConnectThread : WSASocket()" );
		goto ERROR_THREAD;
	}

	// ڑT[o[̃AhXݒ
	SOCKADDR_IN sa_out;
	sa_out.sin_family			= AF_INET;
	sa_out.sin_addr.S_un.S_addr	= ::inet_addr( pTCP->m_STcp.m_sAddr.c_str() );
	sa_out.sin_port				= ::htons( ::atoi( pTCP->m_STcp.m_sPort.c_str() ) );

	// CONNECT
	int nRes = ::WSAConnect( Sock, reinterpret_cast<SOCKADDR*>( &sa_out ), sizeof( sa_out ), NULL, NULL, NULL, NULL );
	if( nRes != SOCKET_ERROR )
	{
		pTCP->m_pLog->SetLog( "NET::TCP TCP/IP T[o[ɐڑ܂" );
		// \Pbgڑ
		pTCP->Connect( &Sock, sa_out );
		goto CONNECT_THREAD;
	}else
		pTCP->m_pLog->SetLog( "NET::TCP TCP/IP T[o[ւ̐ڑɎs" );

ERROR_THREAD:
	::shutdown( Sock, SD_BOTH );
	::closesocket( Sock );

CONNECT_THREAD:
	::_endthreadex( 0 );
	return TRUE;
}

/*******************************************************************************
 *	@fn				void CTCP::Connect( const SOCKET* sock,
 *										const SOCKADDR_IN& out )
 *	@param[in]		sock						ڑ\Pbg
 *	@param[in]		out							AhXƃ|[g
 *	@retval			none						Ȃ
 *	@brief			\Pbgڑ
 ******************************************************************************/
void CTCP::Connect( const SOCKET* sock,
					const SOCKADDR_IN& out )
{
	// 󂢂Ă\Pbgɓn
	int nUsed = 0, nUsedMax = 0;
	for( nUsed = 0; nUsed < m_STcp.m_nMemMax; nUsed++ )
	{
		if( !m_pSock[ nUsed ].GetUsed() )
		{
			char cBuf[ 256 ];
			::sprintf_s( cBuf, 256, "NET::TCP %s:%d Ɛڑ܂", ::inet_ntoa( out.sin_addr ), ::ntohs( out.sin_port ) );
			m_pLog->SetLog( cBuf );
			m_pSock[ nUsed ].Connect( sock, ::inet_ntoa( out.sin_addr ), ::ntohs( out.sin_port ), CSock::SOCK_TCP );
			break;
		}else
			nUsedMax++;
	}
	// 𒴂ꍇ
	if( nUsedMax >= m_STcp.m_nMemMax )
	{
		m_pLog->SetLog( "NET::TCP TCP/IP ڑ𒴂܂" );
		::shutdown( *sock, SD_BOTH );
		::closesocket( *sock );
	}
}

/*******************************************************************************
 *	@fn				CTCP::CTCP( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CTCP::CTCP( void )
	: m_STcp()
	, m_pLog( NULL )
	, m_pSock( NULL )
	, m_nRecvTmp( 0 )
{
	::strcpy_s( m_cHostName, MAXGETHOSTSTRUCT + 1, "" );
	::strcpy_s( m_cIPAddr, 32, "" );
}

/*******************************************************************************
 *	@fn				CTCP::~CTCP( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CTCP::~CTCP( void )
{
}

/*******************************************************************************
 *	@fn				void CTCP::Startup( const SNET& STcp )
 *	@param[in]		STcp						ʐM\
 *	@retval			none						Ȃ
 *	@brief			JnO\̐ݒ
 ******************************************************************************/
void CTCP::Startup( const SNET& STcp )
{
	m_STcp = STcp;
}

/*******************************************************************************
 *	@fn				int CTCP::Init( CLog *pLog,
 *									const char* hostname,
 *									const char* ip )
 *	@param[in]		pLog						OǗNX
 *	@param[in]		hostname					zXg
 *	@param[in]		ip							IPAhX
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CTCP::Init( CLog *pLog,
				const char* hostname,
				const char* ip )
{
	unsigned int uiID;
	HANDLE hID;

	// gp
	if( !m_STcp.m_bServer && !m_STcp.m_bClient ) return TRUE;

	m_pLog = pLog;
	::strcpy_s( m_cHostName, MAXGETHOSTSTRUCT + 1, hostname );
	::strcpy_s( m_cIPAddr, 32, ip );

	// ڑ[U[̍쐬
	m_pSock = new CSock[ m_STcp.m_nMemMax ];
	for( int i = 0; i < m_STcp.m_nMemMax; i++ )
		m_pSock[ i ].Init( m_pLog, m_STcp.m_nBufSize, m_STcp.m_nBufAry );

	// TCP/IPT[o[gp
	if( m_STcp.m_bServer )
	{
		m_pLog->SetLog( "NET::TCP TCP/IP T[o[Jn" );
		hID = reinterpret_cast<HANDLE>( ::_beginthreadex( NULL, 0, &CTCP::AcceptThread, this, 0, &uiID ) );
		::CloseHandle( hID );
	}
	// TCP/IPNCAggp
	if( m_STcp.m_bClient )
	{
		m_pLog->SetLog( "NET::TCP TCP/IP NCAgJn" );
		hID = reinterpret_cast<HANDLE>( ::_beginthreadex( NULL, 0, &CTCP::ConnectThread, this, 0, &uiID ) );
		::CloseHandle( hID );
	}

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CTCP::End( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			I
 *					ׂẴXbhI
 ******************************************************************************/
int CTCP::End( void )
{
	for( int i = 0; i < m_STcp.m_nMemMax; i++ )
		if( &m_pSock[ i ] != NULL )
			m_pSock[ i ].End();
	::Sleep( 1000 );
	// ڑ[U[̍폜
	delete[] m_pSock;

	// TCP/IPT[o[gp
	if( m_STcp.m_bServer )
	{
		// őgݍ
		// TCP/IP\Pbg̍쐬
		SOCKET Sock = ::WSASocket( AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, 0 );

		// ڑT[o[̃AhXݒ
		SOCKADDR_IN sa_in;
		sa_in.sin_family			= AF_INET;
		sa_in.sin_addr.S_un.S_addr	= ::inet_addr( m_cIPAddr );
		sa_in.sin_port				= ::htons( ::atoi( m_STcp.m_sPort.c_str() ) );

		// ɐڑ
		int nRes = ::WSAConnect( Sock, reinterpret_cast<SOCKADDR*>( &sa_in ), sizeof( sa_in ), NULL, NULL, NULL, NULL );

		// Ô߂Pbҋ@
		::Sleep( 1000 );

		// TCP/IPZbV̏I
		::closesocket( Sock );

		m_pLog->SetLog( "NET::TCP TCP/IP T[o[I" );
	}

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CTCP::P2PConnect( const char* cAddr,
 *										  const char* cPort )
 *	@param[in]		cAddr						TCP/IP T[o[IPAhX
 *	@param[in]		cPort						TCP/IP T[o[̃|[gԍ
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			P2Pڑ
 ******************************************************************************/
int CTCP::P2PConnect( const char* cAddr,
					  const char* cPort )
{
	unsigned int uiID;
	HANDLE hID;

	m_STcp.m_sAddr = cAddr;
	m_STcp.m_sPort = cPort;

	m_pLog->SetLog( "NET::TCP TCP/IP P2Pڑ" );
	hID = reinterpret_cast<HANDLE>( ::_beginthreadex( NULL, 0, &CTCP::ConnectThread, this, 0, &uiID ) );
	::CloseHandle( hID );

	return TRUE;
}

/*******************************************************************************
 *	@fn				void CTCP::Send( BYTE* byData )
 *	@param[in]		byData						Mf[^
 *	@retval			none						Ȃ
 *	@brief			f[^̑M
 ******************************************************************************/
void CTCP::Send( BYTE* byData )
{
	for( int i = 0; i < m_STcp.m_nMemMax; i++ )
	{
		if( m_pSock[ i ].GetUsed() )
			m_pSock[ i ].SetPacket( byData );
	}
}

/*******************************************************************************
 *	@fn				const BYTE* CTCP::Recv( void )
 *	@retval			BYTE*						Mf[^
 *	@brief			f[^̎M
 ******************************************************************************/
const BYTE* CTCP::Recv( void )
{
	int nEnd = m_nRecvTmp + m_STcp.m_nMemMax;
	for( int i = m_nRecvTmp; i < nEnd; i++ )
	{
		int nRecv = i % m_STcp.m_nMemMax;
		if( m_pSock[ nRecv ].GetUsed() )
		{
			const BYTE* byData = m_pSock[ nRecv ].GetPacket();
			if( byData != NULL )
			{
				m_nRecvTmp++;
				m_nRecvTmp %= m_STcp.m_nMemMax;
				return byData;
			}
		}
	}
	return NULL;
}

}	// namespace	NET
