/*******************************************************************************
 *	@file			Net.h
 *	@brief			Network Test Program
 *
 *	@author			ohwhsmm7
 *
 *	@date			12-Nov-2011(Sat)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "Net.h"
#include "TCP.h"
#include "UDP.h"

#include <commctrl.h>
#pragma comment ( lib, "comctl32.lib" )
#include "resource.h"

#ifdef _DEBUG
#pragma comment ( lib, "Debug\\_NetLib.lib" )
#else	// _DEBUG
#pragma comment ( lib, "Release\\_NetLib.lib" )
#endif	// _DEBUG

// 񋓌^`-------------------------------------------------------------------

// \̒`-------------------------------------------------------------------

// O[oϐ-----------------------------------------------------------
NET::CTCP*				g_pTcp;
NET::CUDP*				g_pUdp;

const int BUF_SIZE = 4096;
const int BUF_ARY = 32;

int						g_nMem = 0;
char					g_cAddr[ 256 ];
char					g_cPort[ 256 ];

int						g_nTCP = -1;
int						g_nTCPDlg = 0;
int						g_nTCPLogCnt = 0;
int						g_bUDP = FALSE;

int						g_nUDP = -1;

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				BOOL CALLBACK DlgProcInit( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
 *	@retval			LRESULT
 *	@brief			ݒp_CAOvV[W
 ******************************************************************************/
BOOL CALLBACK DlgProcInit( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
			LPARAM lpIP = MAKEIPADDRESS( 192, 168, 11, 2 );
			::SendDlgItemMessage( hWnd, IDC_IPADDRESS1, IPM_SETADDRESS, 0, lpIP );
			::SetDlgItemText( hWnd, IDC_EDIT1, L"12345" );
			::SetDlgItemText( hWnd, IDC_EDIT2, L"5" );

			::SendDlgItemMessage( hWnd, IDC_RADIO4, BM_SETCHECK, BST_CHECKED, 0 );
			::SendDlgItemMessage( hWnd, IDC_CHECK1, BM_SETCHECK, BST_UNCHECKED, 0 );

			::SendDlgItemMessage( hWnd, IDC_RADIO5, BM_SETCHECK, BST_CHECKED, 0 );
		}
		break;
	case WM_COMMAND:
		switch( LOWORD( wParam ) )
		{
		case IDC_BUTTON1:
			{
				DWORD lpIP = 0;
				::SendDlgItemMessage( hWnd, IDC_IPADDRESS1, IPM_GETADDRESS, 0, reinterpret_cast<LPARAM>( &lpIP ) );
				::sprintf_s( g_cAddr, 256, "%d.%d.%d.%d",
							FIRST_IPADDRESS( lpIP ),
							SECOND_IPADDRESS( lpIP ),
							THIRD_IPADDRESS( lpIP ),
							FOURTH_IPADDRESS( lpIP ) );
				::GetDlgItemTextA( hWnd, IDC_EDIT1, g_cPort, 256 );
				if( ::SendDlgItemMessage( hWnd, IDC_RADIO1, BM_GETCHECK, 0, 0 ) ) g_nTCP = 0;
				if( ::SendDlgItemMessage( hWnd, IDC_RADIO2, BM_GETCHECK, 0, 0 ) ) g_nTCP = 1;
				if( ::SendDlgItemMessage( hWnd, IDC_RADIO3, BM_GETCHECK, 0, 0 ) ) g_nTCP = 2;
				if( ::SendDlgItemMessage( hWnd, IDC_RADIO4, BM_GETCHECK, 0, 0 ) ) g_nTCP = 3;
				if( ::SendDlgItemMessage( hWnd, IDC_RADIO5, BM_GETCHECK, 0, 0 ) ) g_nUDP = 0;
				if( ::SendDlgItemMessage( hWnd, IDC_RADIO6, BM_GETCHECK, 0, 0 ) ) g_nUDP = 1;
				if( ::SendDlgItemMessage( hWnd, IDC_RADIO7, BM_GETCHECK, 0, 0 ) ) g_nUDP = 2;
				if( ::SendDlgItemMessage( hWnd, IDC_RADIO8, BM_GETCHECK, 0, 0 ) ) g_nUDP = 3;

				char cMem[ 256 ];
				::GetDlgItemTextA( hWnd, IDC_EDIT2, cMem, 256 );
				g_nMem = ::atoi( cMem );
				g_bUDP = ::SendDlgItemMessage( hWnd, IDC_CHECK1, BM_GETCHECK, 0, 0 );
			}
			::EndDialog( hWnd, TRUE );
			return TRUE;
		}
		break;
	case WM_CLOSE:
	case WM_DESTROY:
		::EndDialog( hWnd, FALSE );
		return TRUE;
	}
	return FALSE;
}

/*******************************************************************************
 *	@fn				BOOL CALLBACK DlgProcTCPSrv( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
 *	@retval			LRESULT
 *	@brief			TCP/IPT[o[p_CAOvV[W
 ******************************************************************************/
BOOL CALLBACK DlgProcTCPSrv( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( g_nTCPDlg )
	{
		// O擾
		int nCnt = NET::GetLogCnt();
		if( nCnt > g_nTCPLogCnt )
		{
			std::string str = NET::GetLog( g_nTCPLogCnt );
			char cBuf[ 256 ];
			::sprintf_s( cBuf, 256, "%s\n", str.c_str() );
			::SendDlgItemMessageA( hWnd, IDC_LIST1, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( cBuf ) );
			g_nTCPLogCnt++;
		}
		// f[^M
		{
			if( g_pTcp != NULL )
			{
				const BYTE* byData = g_pTcp->Recv();
				if( byData != NULL )
				{
					char cBuf[ BUF_SIZE ];
					::memcpy_s( cBuf, BUF_SIZE, byData, BUF_SIZE );
					::SendDlgItemMessageA( hWnd, IDC_LIST1, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( cBuf ) );

					g_pTcp->Send( reinterpret_cast<BYTE*>( cBuf ) );
				}
			}
			if( g_pUdp != NULL )
			{
				const BYTE* byData = g_pUdp->Recv();
				if( byData != NULL )
				{
					char cBuf[ BUF_SIZE ];
					::memcpy_s( cBuf, BUF_SIZE, byData, BUF_SIZE );
					::SendDlgItemMessageA( hWnd, IDC_LIST1, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( cBuf ) );

					g_pUdp->Send( reinterpret_cast<BYTE*>( cBuf ) );
				}
			}
		}
	}

	switch( uMsg )
	{
	case WM_INITDIALOG:
		g_nTCPDlg = 1;
		break;
	case WM_CLOSE:
	case WM_DESTROY:
		::EndDialog( hWnd, FALSE );
		return TRUE;
	}
	return FALSE;
}

/*******************************************************************************
 *	@fn				BOOL CALLBACK DlgProcTCPCli( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
 *	@retval			LRESULT
 *	@brief			TCP/IPNCAgp_CAOvV[W
 ******************************************************************************/
BOOL CALLBACK DlgProcTCPCli( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( g_nTCPDlg )
	{
		// O擾
		int nCnt = NET::GetLogCnt();
		if( nCnt > g_nTCPLogCnt )
		{
			std::string str = NET::GetLog( g_nTCPLogCnt );
			char cBuf[ 256 ];
			::sprintf_s( cBuf, 256, "%s\n", str.c_str() );
			::SendDlgItemMessageA( hWnd, IDC_LIST1, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( cBuf ) );
			g_nTCPLogCnt++;
		}
		// f[^M
		{
			if( g_pTcp != NULL )
			{
				const BYTE* byData = g_pTcp->Recv();
				if( byData != NULL )
				{
					char cBuf[ BUF_SIZE ];
					::memcpy_s( cBuf, BUF_SIZE, byData, BUF_SIZE );
					::SendDlgItemMessageA( hWnd, IDC_LIST1, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( cBuf ) );
				}
			}
			if( g_pUdp != NULL )
			{
				const BYTE* byData = g_pUdp->Recv();
				if( byData != NULL )
				{
					char cBuf[ BUF_SIZE ];
					::memcpy_s( cBuf, BUF_SIZE, byData, BUF_SIZE );
					::SendDlgItemMessageA( hWnd, IDC_LIST1, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( cBuf ) );
				}
			}
		}
	}

	switch( uMsg )
	{
	case WM_INITDIALOG:
		g_nTCPDlg = 1;
		break;
	case WM_COMMAND:
		switch( LOWORD( wParam ) )
		{
		case IDC_BUTTON2:
			{
				char cBuf[ BUF_SIZE ];
				::GetDlgItemTextA( hWnd, IDC_EDIT3, cBuf, BUF_SIZE );

				if( g_pTcp != NULL )
					g_pTcp->Send( reinterpret_cast<BYTE*>( cBuf ) );
				if( g_pUdp != NULL )
					g_pUdp->Send( reinterpret_cast<BYTE*>( cBuf ) );
			}
			break;
		}
		break;
	case WM_CLOSE:
	case WM_DESTROY:
		::EndDialog( hWnd, FALSE );
		return TRUE;
	}
	return FALSE;
}

/*******************************************************************************
 *	@fn				BOOL CALLBACK DlgProcTCPP2P( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
 *	@retval			LRESULT
 *	@brief			TCP/IPP2Pp_CAOvV[W
 ******************************************************************************/
BOOL CALLBACK DlgProcTCPP2P( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if( g_nTCPDlg )
	{
		// O擾
		int nCnt = NET::GetLogCnt();
		if( nCnt > g_nTCPLogCnt )
		{
			std::string str = NET::GetLog( g_nTCPLogCnt );
			char cBuf[ 256 ];
			::sprintf_s( cBuf, 256, "%s\n", str.c_str() );
			::SendDlgItemMessageA( hWnd, IDC_LIST1, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( cBuf ) );
			g_nTCPLogCnt++;
		}
		// f[^M
		{
			const BYTE* byData = g_pTcp->Recv();
			if( byData != NULL )
			{
				char cBuf[ BUF_SIZE ];
				::memcpy_s( cBuf, BUF_SIZE, byData, BUF_SIZE );
				::SendDlgItemMessageA( hWnd, IDC_LIST1, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( cBuf ) );

				// VKP2PT[o[
				if( ::strncmp( cBuf, "P2PSERVER:", 10 ) == 0 )
				{
					char *cTmp = NULL, *cAddr = NULL, *cPort = NULL, *cNext = NULL;
					cTmp = ::strtok_s( cBuf, ":", &cNext );
					cAddr = ::strtok_s( NULL, ":", &cNext );
					cPort = ::strtok_s( NULL, "\0", &cNext );

					char cBuf[ BUF_SIZE ];
					::sprintf_s( cBuf, "NEWSERVER:%s:%s", cAddr, cPort );
					// f[^M
					g_pTcp->Send( reinterpret_cast<BYTE*>( cBuf ) );
				}
				if( ::strncmp( cBuf, "NEWSERVER:", 10 ) == 0 )
				{
					char *cTmp = NULL, *cAddr = NULL, *cPort = NULL, *cNext = NULL;
					cTmp = ::strtok_s( cBuf, ":", &cNext );
					cAddr = ::strtok_s( NULL, ":", &cNext );
					cPort = ::strtok_s( NULL, "\0", &cNext );
					// ȊO
					if( ( ::strcmp( g_cAddr, cAddr ) != 0 ) || ( ::strcmp( g_cPort, cPort ) != 0 ) )
						g_pTcp->P2PConnect( cAddr, cPort );
				}
			}
		}
	}

	switch( uMsg )
	{
	case WM_INITDIALOG:
		g_nTCPDlg = 1;
		break;
	case WM_COMMAND:
		switch( LOWORD( wParam ) )
		{
		case IDC_BUTTON2:
			{
				char cBuf[ BUF_SIZE ];
				::GetDlgItemTextA( hWnd, IDC_EDIT3, cBuf, BUF_SIZE );

				// VKڑ
				if( ::strncmp( cBuf, "NEWCONNECT:", 11 ) == 0 )
				{
					char *cTmp = NULL, *cAddr = NULL, *cPort = NULL, *cNext = NULL;
					cTmp = ::strtok_s( cBuf, ":", &cNext );
					cAddr = ::strtok_s( NULL, ":", &cNext );
					cPort = ::strtok_s( NULL, "\0", &cNext );

					g_pTcp->P2PConnect( cAddr, cPort );
				}else
					// f[^M
					g_pTcp->Send( reinterpret_cast<BYTE*>( cBuf ) );
			}
			break;
		}
		break;
	case WM_CLOSE:
	case WM_DESTROY:
		::EndDialog( hWnd, FALSE );
		return TRUE;
	}
	return FALSE;
}

/*******************************************************************************
 *	@fn				int WINAPI WinMain( HINSTANCE hInstance,
 *									    HINSTANCE hPrevInstance,
 *										LPSTR lpCmdLine,
 *										int nCmdShow )
 *	@param[in]		hInstance		CX^Xnh
 *	@param[in]		hPrevInstance	CX^Xnh
 *	@param[in]		lpCmdLine		
 *	@param[in]		nCmdShow		
 *	@retval			LRESULT			
 *	@brief			vON
 ******************************************************************************/
int WINAPI WinMain( HINSTANCE hInstance,
				    HINSTANCE hPrevInstance,
					LPSTR lpCmdLine,
					int nCmdShow )
{
	// ݒ
	if( ::DialogBox( hInstance, MAKEINTRESOURCE( IDD_INIT ), NULL, reinterpret_cast<DLGPROC>( DlgProcInit ) ) )
	{
		// gpNX̐ݒƎ擾
		switch( g_nTCP )
		{
		case 0: g_pTcp = reinterpret_cast<NET::CTCP*>( NET::StartupTCP( TRUE, FALSE, g_nMem, g_cAddr, g_cPort, BUF_SIZE, BUF_ARY ) ); break;
		case 1: g_pTcp = reinterpret_cast<NET::CTCP*>( NET::StartupTCP( FALSE, TRUE, g_nMem, g_cAddr, g_cPort, BUF_SIZE, BUF_ARY ) ); break;
		case 2: g_pTcp = reinterpret_cast<NET::CTCP*>( NET::StartupTCP( TRUE, FALSE, g_nMem, g_cAddr, g_cPort, BUF_SIZE, BUF_ARY ) ); break;
		case 3: break;
		}
		switch( g_nUDP )
		{
		case 0: g_pUdp = reinterpret_cast<NET::CUDP*>( NET::StartupUDP( TRUE, FALSE, g_nMem, g_cAddr, g_cPort, BUF_SIZE, BUF_ARY ) ); break;
		case 1: g_pUdp = reinterpret_cast<NET::CUDP*>( NET::StartupUDP( FALSE, TRUE, g_nMem, g_cAddr, g_cPort, BUF_SIZE, BUF_ARY ) ); break;
		case 2: break;
		case 3: break;
		}

		// Network ̏
		NET::Init();

		switch( g_nTCP )
		{
		case 0: ::DialogBox( hInstance, MAKEINTRESOURCE( IDD_TCPSRV ), NULL, reinterpret_cast<DLGPROC>( DlgProcTCPSrv ) ); break;
		case 1: ::DialogBox( hInstance, MAKEINTRESOURCE( IDD_TCPCLI ), NULL, reinterpret_cast<DLGPROC>( DlgProcTCPCli ) ); break;
		case 2: ::DialogBox( hInstance, MAKEINTRESOURCE( IDD_TCPCLI ), NULL, reinterpret_cast<DLGPROC>( DlgProcTCPP2P ) ); break;
		case 3: break;
		}
		switch( g_nUDP )
		{
		case 0: ::DialogBox( hInstance, MAKEINTRESOURCE( IDD_TCPSRV ), NULL, reinterpret_cast<DLGPROC>( DlgProcTCPSrv ) ); break;
		case 1: ::DialogBox( hInstance, MAKEINTRESOURCE( IDD_TCPCLI ), NULL, reinterpret_cast<DLGPROC>( DlgProcTCPCli ) ); break;
		case 2: break;
		case 3: break;
		}

		// Network ̏I
		NET::End();
	}

    return EXIT_SUCCESS;
}
