/*******************************************************************************
 *	@file			UDP.cpp
 *	@brief			Network Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			26-Jan-2012(Thu)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "UDP.h"

/*******************************************************************************
 *	@namespace	NET
 ******************************************************************************/
namespace	NET
{

// O[oϐ-----------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				CUDP::UnicastThread( void *p )
 *	@param[in]		p							ėp
 *	@retval			unsigned					TRUE
 *	@brief			jLXgpXbh
 ******************************************************************************/
unsigned __stdcall CUDP::UnicastThread( void *p )
{
	CUDP *pUDP = reinterpret_cast<CUDP*>( p );

	// UDP/IP\Pbg̍쐬
	SOCKET Sock;
	Sock = ::WSASocket( AF_INET, SOCK_DGRAM, IPPROTO_UDP, NULL, 0, 0 );
	if( Sock == INVALID_SOCKET )
	{
		assert( 0 && "UnicastThread : WSASocket()" );
		goto ERROR_THREAD;
	}

	// MAhXƃ|[gݒ
	SOCKADDR_IN sa_in;
	sa_in.sin_family			= AF_INET;
	sa_in.sin_addr.S_un.S_addr	= ::inet_addr( pUDP->m_cIPAddr );
	sa_in.sin_port				= ::htons( ::atoi( pUDP->m_SUdp.m_sPort.c_str() ) );

	// 쐬\PbgɃAhXƃ|[g֘At
	if( ::bind( Sock, reinterpret_cast<SOCKADDR*>( &sa_in ), sizeof( SOCKADDR ) ) != 0 )
	{
		assert( 0 && "UnicastThread : bind()" );
		goto ERROR_THREAD;
	}

	DWORD dwBytes = 0, dwFlags = 0;
	int nRecvCnt = 0;
	char *cBuf = new CHAR[ pUDP->m_SUdp.m_nBufSize ];

	// Mobt@
	WSABUF wsaBuf;
	wsaBuf.buf = cBuf;
	wsaBuf.len = pUDP->m_SUdp.m_nBufSize;

	// MCxg
	WSAOVERLAPPED wsaOver;
	WSANETWORKEVENTS wsaEvents;

	// Cxg쐬
	// ʒme
	// @FD_ACCEPTȂCNCAgڑv͂Ă邱Ƃʒm܂B
	// AFD_CONNECTȂC\Pbgւ̐ڑƂʒm܂B
	// BFD_WRITÉC\Pbg̑Mobt@ɋ󂫂łƂʒm܂B
	// CFD_READ́C\Pbg̎Mobt@Ƀf[^邱Ƃʒm܂B
	// DFD_CLOSÉC\Pbgւ̐ڑIƂʒm܂B
	wsaOver.hEvent = ::WSACreateEvent();
	if( wsaOver.hEvent == NULL )
		goto ERROR_THREAD;

	// UDP͓ǂݏȂ̂Ň@ƇA͊܂܂Ȃ
	if( ::WSAEventSelect( Sock, wsaOver.hEvent, FD_READ | FD_WRITE | FD_CLOSE ) != 0 )
		goto ERROR_THREAD;

	pUDP->m_pLog->SetLog( "NET::UDP UDP/IP MJn" );

	// MAhXƃ|[gݒ
	SOCKADDR_IN sa_out;
	sa_out.sin_family			= AF_INET;

	int nAddrSize = sizeof( SOCKADDR );

	int nRes = -1;
	// M[v
	while( 1 )
	{
		dwBytes = 0;
		nRes = ::WSAWaitForMultipleEvents( 1, &wsaOver.hEvent, FALSE, CSock::TIMEWAIT_UDP, FALSE );
		if( nRes == WSA_WAIT_FAILED )
			::shutdown( Sock, SD_SEND );

		::WSAEnumNetworkEvents( Sock, wsaOver.hEvent, &wsaEvents );

		// ؒf
		if( !pUDP->m_bConnect )
		{
			::shutdown( Sock, SD_SEND );
			break;
		}
		
		// f[^̑M
		for( int i = 0; i < pUDP->m_SUdp.m_nMemMax; i++ )
		{
			CSock *pSock = &pUDP->m_pSock[ i ];
			if( pSock->GetUsed() )
			{
				sa_out.sin_addr.S_un.S_addr	= ::inet_addr( pSock->GetIPAddr() );
				sa_out.sin_port				= ::htons( pSock->GetPort() );

				// Mf[^o^
				const BYTE* byData = pSock->SetPacket();
				if( byData != NULL )
				{
					wsaBuf.buf = reinterpret_cast<CHAR*>( const_cast<BYTE*>( byData ) );

					nRes = ::WSASendTo( Sock, &wsaBuf, 1, &dwBytes, dwFlags, reinterpret_cast<SOCKADDR*>( &sa_out ), nAddrSize, &wsaOver, NULL );
					if( nRes != SOCKET_ERROR )
					{
					}
				}
			}
		}

		// f[^̎M
		if( wsaEvents.lNetworkEvents & FD_READ )
		{
			// Mf[^擾
			::memset( wsaBuf.buf, 0, pUDP->m_SUdp.m_nBufSize );

			nRes = ::WSARecvFrom( Sock, &wsaBuf, 1, &dwBytes, &dwFlags, reinterpret_cast<SOCKADDR*>( &sa_out ), &nAddrSize, &wsaOver, NULL );
			if( nRes != SOCKET_ERROR )
			{
				// ڑĂAhXg̏ꍇAIƂ݂Ȃ[vEo
				if( ::strcmp( pUDP->m_cIPAddr, ::inet_ntoa( sa_out.sin_addr ) ) == 0 )
				{
					::closesocket( Sock );
					break;
				}

				// VKڑ̃f[^MɑΉ
				for( int i = 0; i < 2; i++ )
				{
					// MIP
					int nUse = 0, nUseMax = 0;
					for( nUse = 0; nUse < pUDP->m_SUdp.m_nMemMax; nUse++ )
					{
						CSock *pSock = &pUDP->m_pSock[ nUse ];
						if( pSock->GetUsed() )
						{
							// IP
							if( ::strcmp( pSock->GetIPAddr(), ::inet_ntoa( sa_out.sin_addr ) ) == 0 )
							{
								// Mf[^ۑ
								pSock->GetPacket( reinterpret_cast<BYTE*>( wsaBuf.buf ) );
								break;
							}else
								nUseMax++;
						}else
							nUseMax++;
					}
					// VKڑ
					if( nUseMax >= pUDP->m_SUdp.m_nMemMax )
					{
						pUDP->Connect( &Sock, sa_out, CSock::SOCK_DUMMY );
					}else
						break;
				}
			}
		}

		// \Pbg̐ؒf
		if( wsaEvents.lNetworkEvents & FD_CLOSE )
			break;

		// ҋ@
		::Sleep( 1 );
		::WSAResetEvent( wsaOver.hEvent );
	}

ERROR_THREAD:
	::shutdown( Sock, SD_BOTH );
	if( wsaOver.hEvent != NULL )
		::WSACloseEvent( wsaOver.hEvent );
	::closesocket( Sock );
	pUDP->m_bConnect = FALSE;

	pUDP->m_pLog->SetLog( "NET::UDP UDP/IP MI" );

	delete[] cBuf;

	::_endthreadex( 0 );
	return TRUE;
}

/*******************************************************************************
 *	@fn				CUDP::ConnectThread( void *p )
 *	@param[in]		p							ėp
 *	@retval			unsigned					TRUE
 *	@brief			ڑpXbh
 ******************************************************************************/
unsigned __stdcall CUDP::ConnectThread( void *p )
{
	CUDP *pUDP = reinterpret_cast<CUDP*>( p );

	// UDP/IP\Pbg̍쐬
	SOCKET Sock;
	Sock = ::WSASocket( AF_INET, SOCK_DGRAM, IPPROTO_UDP, NULL, 0, 0 );
	if( Sock == INVALID_SOCKET )
	{
		assert( 0 && "ConnectThread : WSASocket()" );
		goto ERROR_THREAD;
	}

	// ڑT[o[̃AhXݒ
	SOCKADDR_IN sa_out;
	sa_out.sin_family			= AF_INET;
	sa_out.sin_addr.S_un.S_addr	= ::inet_addr( pUDP->m_SUdp.m_sAddr.c_str() );
	sa_out.sin_port				= ::htons( ::atoi( pUDP->m_SUdp.m_sPort.c_str() ) );

	// \Pbgڑ
	pUDP->Connect( &Sock, sa_out );

	goto CONNECT_THREAD;

ERROR_THREAD:
	::shutdown( Sock, SD_BOTH );
	::closesocket( Sock );

CONNECT_THREAD:
	::_endthreadex( 0 );
	return TRUE;
}


/*******************************************************************************
 *	@fn				void CUDP::Connect( const SOCKET* sock,
 *										const SOCKADDR_IN& out,
 *										const int nSock )
 *	@param[in]		sock						ڑ\Pbg
 *	@param[in]		out							AhXƃ|[g
 *	@param[in]		nSock						ڑ@
 *	@retval			none						Ȃ
 *	@brief			\Pbgڑ
 ******************************************************************************/
void CUDP::Connect( const SOCKET* sock,
					const SOCKADDR_IN& out,
					const int nSock )
{
	// 󂢂Ă\Pbgɓn
	int nUsed = 0, nUsedMax = 0;
	for( nUsed = 0; nUsed < m_SUdp.m_nMemMax; nUsed++ )
	{
		if( !m_pSock[ nUsed ].GetUsed() )
		{
			char cBuf[ 256 ];
			::sprintf_s( cBuf, 256, "NET::UDP %s:%d Ɛڑ܂", ::inet_ntoa( out.sin_addr ), ::ntohs( out.sin_port ) );
			m_pLog->SetLog( cBuf );
			m_pSock[ nUsed ].Connect( sock, ::inet_ntoa( out.sin_addr ), ::ntohs( out.sin_port ), nSock );
			break;
		}else
			nUsedMax++;
	}
	// 𒴂ꍇ
	if( nUsedMax >= m_SUdp.m_nMemMax )
	{
		m_pLog->SetLog( "NET::UDP UDP/IP ڑ𒴂܂" );
		::shutdown( *sock, SD_BOTH );
		::closesocket( *sock );
	}
}

/*******************************************************************************
 *	@fn				CUDP::CUDP( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CUDP::CUDP( void )
	: m_SUdp()
	, m_pLog( NULL )
	, m_pSock( NULL )
	, m_bConnect( FALSE )
	, m_nRecvTmp( 0 )
{
	::strcpy_s( m_cHostName, MAXGETHOSTSTRUCT + 1, "" );
	::strcpy_s( m_cIPAddr, 32, "" );
}

/*******************************************************************************
 *	@fn				CUDP::~CUDP( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CUDP::~CUDP( void )
{
}

/*******************************************************************************
 *	@fn				void CUDP::Startup( const SNET& SUdp )
 *	@param[in]		SUdp						ʐM\
 *	@retval			none						Ȃ
 *	@brief			JnO\̐ݒ
 ******************************************************************************/
void CUDP::Startup( const SNET& SUdp )
{
	m_SUdp = SUdp;
}

/*******************************************************************************
 *	@fn				int CUDP::Init( CLog *pLog,
 *									const char* hostname,
 *									const char* ip )
 *	@param[in]		pLog						OǗNX
 *	@param[in]		hostname					zXg
 *	@param[in]		ip							IPAhX
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CUDP::Init( CLog *pLog,
				const char* hostname,
				const char* ip )
{
	unsigned int uiID;
	HANDLE hID;

	// gp
	if( !m_SUdp.m_bServer && !m_SUdp.m_bClient ) return TRUE;

	m_pLog = pLog;
	::strcpy_s( m_cHostName, MAXGETHOSTSTRUCT + 1, hostname );
	::strcpy_s( m_cIPAddr, 32, ip );
	m_bConnect = TRUE;

	// ڑ[U[̍쐬
	m_pSock = new CSock[ m_SUdp.m_nMemMax ];
	for( int i = 0; i < m_SUdp.m_nMemMax; i++ )
		m_pSock[ i ].Init( m_pLog, m_SUdp.m_nBufSize, m_SUdp.m_nBufAry );

	// UDP/IPT[o[gp
	if( m_SUdp.m_bServer )
	{
		m_pLog->SetLog( "NET::UDP UDP/IP T[o[Jn" );
		hID = reinterpret_cast<HANDLE>( ::_beginthreadex( NULL, 0, &CUDP::UnicastThread, this, 0, &uiID ) );
		::CloseHandle( hID );
	}
	// UDP/IPNCAggp
	if( m_SUdp.m_bClient )
	{
		m_pLog->SetLog( "NET::UDP UDP/IP NCAgJn" );
		hID = reinterpret_cast<HANDLE>( ::_beginthreadex( NULL, 0, &CUDP::ConnectThread, this, 0, &uiID ) );
		::CloseHandle( hID );
	}

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CUDP::End( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			I
 *					ׂẴXbhI
 ******************************************************************************/
int CUDP::End( void )
{
	for( int i = 0; i < m_SUdp.m_nMemMax; i++ )
		if( &m_pSock[ i ] != NULL )
			m_pSock[ i ].End();
	::Sleep( 1000 );
	// ڑ[U[̍폜
	delete[] m_pSock;

	m_bConnect = FALSE;

	return TRUE;
}

/*******************************************************************************
 *	@fn				void CUDP::Send( BYTE* byData )
 *	@param[in]		byData						Mf[^
 *	@retval			none						Ȃ
 *	@brief			f[^̑M
 ******************************************************************************/
void CUDP::Send( BYTE* byData )
{
	for( int i = 0; i < m_SUdp.m_nMemMax; i++ )
	{
		if( m_pSock[ i ].GetUsed() )
			m_pSock[ i ].SetPacket( byData );
	}
}

/*******************************************************************************
 *	@fn				const BYTE* CTCP::Recv( void )
 *	@retval			BYTE*						Mf[^
 *	@brief			f[^̎M
 ******************************************************************************/
const BYTE* CUDP::Recv( void )
{
	int nEnd = m_nRecvTmp + m_SUdp.m_nMemMax;
	for( int i = m_nRecvTmp; i < nEnd; i++ )
	{
		int nRecv = i % m_SUdp.m_nMemMax;
		if( m_pSock[ nRecv ].GetUsed() )
		{
			const BYTE* byData = m_pSock[ nRecv ].GetPacket();
			if( byData != NULL )
			{
				m_nRecvTmp++;
				m_nRecvTmp %= m_SUdp.m_nMemMax;
				return byData;
			}
		}
	}
	return NULL;
}

}	// namespace	NET
